{ Fido Pascal Conference  PASCAL 
Msg  : 356 of 375
From : Bob Swart                           2:281/256.12         27 May 93  16:01
To   : Wilbert van Leijen                  2:281/256.14
Subj : 3 Variations On A Theme

Hi Wilbert!

 > Procedure UpCaseStr2(Var s : String); Assembler;
[...]

 > @1:     LODSB
 >         SUB    AL, 'a'
 >         CMP    AL, 'z'-'a'+1
 >         SBB    AH, AH
 >         AND    AH, 'a'-'A'
 >         SUB    AL, AH
 >         ADD    AL, 'a'
 >         STOSB
 >         LOOP   @1
Interesting loop you've got here. I've never seen something like this before!

 >    Procedure     Size     Execution timing*
 >                  (bytes)  (seconds)

 >    UpCaseStr0    76       4.32      = 1.00
 >    UpCaseStr1    67       2.76      = 0.63
 >    UpCaseStr2    39       1.31      = 0.30

I've converted your UpCaseStr2 to an InLine macro and speed it up somewhat.
However, here are my results:

len   FUNC  PROC  BASF  INLM  WILB  W-IN  COUN
  1:   100   135   120   254   161   237   170  = reps per clocktick
  3:   100   120   150   290   196   270   215
  7:   100   112   192   321   187   306   279
 15:   100   107   240   376   292   339   353
 31:   100   103   279   394   330   360   417
 63:   100   102   308   417   355   373   463
127:   100   100   322   424   367   377   487
255:   100   100   328   421   370   377   498

 len = length of test string (all were given same random teststrings)
FUNC = Pascal Function
PROC = Pascal Procedure
BASF = Basm Function
INLM = InLine Macro (procedure Upper4)
WILB = your procedure UpcaseStr2 using SSB
W-IN = your procedure as an InLine macro
COUN = Country Specific Routine using XLAT

The following remains the fastest all-purpose UpperCase routine (using only 32
bytes):}

  procedure Upper4(var Str: String);
  InLine(
    $8C/$DA/               {      mov   DX,DS               }
    $5E/                   {      pop   SI                  }
    $1F/                   {      pop   DS                  }
    $FC/                   {      cld                       }
    $AC/                   {      lodsb                     }
    $30/$E4/               {      xor   AH,AH               }
    $89/$C1/               {      mov   CX,AX               }
    $E3/$12/               {      jcxz  @30                 }
    $BB/Ord('a')/Ord('z')/ {      mov   BX,'za'             }
    $AC/                   { @15: lodsb                     }
    $38/$D8/               {      cmp   AL,BL               }
    $72/$08/               {      jb    @28                 }
    $38/$F8/               {      cmp   AL,BH               }
    $77/$04/               {      ja    @28                 }
    $80/$6C/$FF/$20/       {      sub   BYTE PTR [SI-1],$20 }
    $E2/$F1/               { @28: loop  @15                 }
    $8E/$DA);              { @30: mov   DS,DX               }

 >    *30,000 times on a 40 MHz 386
Tested on a 33 Mhz 386.